#!/bin/bash
############################################################
# source: program_templete.sh
# author: devenkong(18151155@qq.com)
# date: 2022-07-28
############################################################
# Copyright (C) 2022- Free Software Foundation, Inc.
# This configure script is free software; the Free Software 
# Foundation gives unlimited permission to copy, distribute 
# and modify it.
############################################################
# note:
#     it is a templete of application program. it's the orignal
# version of shlibopt.
#     it include shlibs, and process argments with getopts
# cmd.
############################################################

#
# todo：
# @ 
# @ 
#

. shlibinc


##############################
# section: shlib include
##############################

include stdio.shlib
include shlib_templete.shlib


##############################
# section: public comment info
##############################




##############################
# section: variable define
##############################




##############################
# section: private function
##############################




##############################
# section: public function
##############################


prog_usage='
syntax: prog [option] <paramter>
description: set paramters for shlib using.

 -g        get shlib path.
 -a <path> append path to shlib path.
 -d [N]    delete the N th path item. zero or none paramter delete 
           the latest path in shlib path.
		   
 -l        list shlib files in include path.
 -i <file> install file to shlib path.
 -u <file> uninstall file from shlib path.
		   
 -b        init shlib on system boot.
 -s <user> init shlib on session init.
 -p        init shlib on program start.
		   
 -v        print shlib version info.
 -h        helper information.
'



#
# main <eval-str>
#
main ()
{
	local varin=$1
	local varout=$2
	local tmp
	
	#
	# use stderr as dbgout channel.
	#
	init_dbglogout 2 :example 20000
	
	info "$0 is running."
	dbgout "output debug string.\n"
	err "output err string."
	logout "log string for test."
	
	#
	# args dispatch
	#
	while getopts :ga:d:li:u:bspvh opt; do
		eval optstr=\${$OPTIND}
		case "$opt" in
			g)
			get_shlib_path
			;;
			a)
			echo "OPTIND=$OPTIND"
			echo "optstr=$optstr"
			add_shlib_path "$2"
			shift
			;;
			d)
			del_shlib_path "$1"
			shift
			;;
			
			l)
			get_shlib_path | while read line; do
				echo -ne "\033[32m[$line]\n\033[0m"
				find $line/* | grep -E "\.shlib"
			done
			;;
			i)
			tmp=( $(get_shlib_path) )
			cp $2 $tmp
			;;
			u)
			tmp=( $(get_shlib_path) )
			ls $tmp
			rm $tmp/$2
			;;
			
			b)
			if [[ -z "$(cat $ROOTFS/etc/bash.bashrc | grep -E '. shlibinc')" ]]; then
				echo ". shlibinc" > $ROOTFS/etc/bash.bashrc
			fi
			;;
			s)
			if [[ -z "$(cat $ROOTFS/home/$user/.bashrc | grep -E '. shlibinc')" ]]; then
				echo ". shlibinc" > $ROOTFS/home/$user/.bashrc
			fi
			;;
			p)
			#
			;;
			
			v)
			info "shlib v$SHLIB_VERSION"
			;;
			h)
			info "$prog_usage"
			;;
			*)
			warn "does not use '-$opt' opt.\n"
			;;
		esac
		shift
	done
}


main "$@"

##############################
# section: file tail
##############################


