#!/bin/bash
############################################################
# source: shlibinst.sh
# author: devenkong(18151155@qq.com)
# date: 2021-09-06
############################################################
# note:
#     shlib库文件的安装。
############################################################

#
# todo：
# @ 
# @ 
#

soft_name="shlib-lite"

shopt -s expand_aliases

if [[ -z $ROOTFS ]]; then
	# 这里的ROOTFS定义与fsvar.shlib中的相同，为减少source文件包含，将代码copy使用。
	TMP_DIR="`dirname $(which ls)`/.."
	TMP_DIR="`cd $TMP_DIR; pwd; cd - >/dev/null`"
	ROOTFS=${ROOTFS:-$TMP_DIR}
	unset TMP_DIR
	
#	SHLIB_PATH=$ROOTFS/usr/lib/shlib:$ROOTFS/usr/libexec/$soft_name/shlib
fi


SHLIB_PATH=$ROOTFS/usr/shlib

SRC_DIR=$PWD
DST_DIR=$ROOTFS/usr/libexec/$soft_name



mkdir $ROOTFS/usr/libexec/$soft_name/shlib/ -pv
#cp $SRC_DIR/$soft_name/fsvar.shlib $ROOTFS/usr/libexec/dvar/shlib/dvar -ravf
#cp bin/dsource $ROOTFS/bin/ -ravf
rm $ROOTFS/bin/install.sh -vf
cp $SRC_DIR/install.sh $ROOTFS/bin/ -ravf
rm $ROOTFS/bin/fix-shebang -vf
cp $SRC_DIR/bin/fix-shebang $ROOTFS/bin/ -ravf
chmod +x $ROOTFS/bin/fix-shebang $ROOTFS/bin/install.sh 
# $ROOTFS/bin/dsource

fix-shebang -c $ROOTFS/bin/fix-shebang $ROOTFS/bin/install.sh 
# $ROOTFS/bin/dsource


# ls命令是系统必备命令，通常位于/bin目录下，以该命令路径获取/根目录路径，
# 以便在交叉编译环境，或android终端app软件这样的运行环境下，获取根目录路径。
#ROOTFS=`dirname $(which ls)`/..



######################
# section: 公用注释信息
######################



######################
# section: 变量定义
######################




######################
# section: private函数
######################

fmt_cvt ()
{
	
	# bin目录下的命令在系统bin目录下建立链接文件
	# 部分文件在修改代码时使用windows下的编辑器后，
	# 产生\r字符而使得脚本运行异常，这里转换成unix格式的换行符。
	echo convert dos format to unix format file and fix shebang ...
	pwd
	chmod +x -R  $DST_DIR/bin/*  $DST_DIR/shlib/*  $DST_DIR/testing/*
	echo bin
	for file in `cd $DST_DIR/bin; find *`; do
#	    echo file：$DST_DIR/bin/$file
	    dos2unix $DST_DIR/bin/$file 2>&1 > /dev/null
	    fix-shebang -t .sh -s bash -c -v $DST_DIR/bin/$file
	    ln -sf $DST_DIR/bin/$file $ROOTFS/bin/$file
	done
	
	echo shlib/$soft_name
	rm $ROOTFS/usr/shlib/$soft_name -f
	mkdir $ROOTFS/usr/shlib/$soft_name -pv
#	ln -sf $DST_DIR/shlib/$soft_name/ $ROOTFS/usr/shlib/$soft_name
	for file in `cd $DST_DIR/shlib/; find *`; do
#	    echo file：$DST_DIR/shlib/$soft_name/$file
	    dos2unix $DST_DIR/shlib/$file 2>&1 > /dev/null
	    fix-shebang -t .sh -s bash -c -v $DST_DIR/shlib/$file
		tmp=`dirname $ROOTFS/usr/shlib/$file`
		[[ ! -e $tmp ]] && mkdir $tmp -pv
	    ln -sf $DST_DIR/shlib/$file $ROOTFS/usr/shlib/$file
	done
	
#	echo shlib
##	for file in `cd $DST_DIR/shlib; find -maxdepth 1 *`; do
#	for file in `cd $DST_DIR/shlib; ls .`; do
##	    echo file：$DST_DIR/shlib/$file
#	    ln -sf $DST_DIR/shlib/$file $ROOTFS/usr/shlib/$file
#		[[ -d $file ]] && continue
#	    dos2unix $DST_DIR/shlib/$file 2> /dev/null
#	    fix-shebang -t .sh -s bash -c -v $DST_DIR/shlib/$file
#	done

	echo testing
	for file in `cd $DST_DIR/testing; find *`; do
#	    echo file：$DST_DIR/$file
		dos2unix $DST_DIR/testing/$file 2> /dev/null
	    fix-shebang -t .sh -s bash -c -v $DST_DIR/testing/$file
#	    ln -sf $DST_DIR/testing/$file $ROOTFS/bin/$file
	done
	
	# 修改库和程序的shebang
#	echo fix shebang infomation ...
#	find $DST_DIR/* | xargs fix-shebang
	
	# etc设置更新，初始化
#	[[ -f $ROOTFS/etc/fsvar.shlib ]]  && sed -i -e "s/ROOTFS.$/ROOTFS=$ROOTFS/g" $ROOTFS/etc/fsvar.shlib

#    source /data/data/com.termux/files/usr/usr/libexec/$soft_name/shlib/$soft_name/fsvar.shlib
	
#	fv_sys_init
	
#	fv_testing
}




# 
install ()
{
	local tmp
	
	# 在安卓系统下，SRC_DIR目录可能是不可运行的，也无法修改其中的文件，所以将部分命令复制到DST_DIR运行
#	cp install.sh $ROOTFS/bin -vf
#	cp bin/dsource $ROOTFS/bin -vf
#	cp bin/fix-shebang $ROOTFS/bin -vf
	
	echo delete installed files ...
	rm $DST_DIR -rf

	echo install ...
	
	# copy文件
	mkdir $ROOTFS/usr/shlib -pv
	mkdir $DST_DIR/{bin,shlib} -pv
	cp $SRC_DIR/bin $DST_DIR/ -ravf
	chmod +x $DST_DIR/bin/*

	cp $SRC_DIR/shlib/ $DST_DIR/ -ravf

#	cp $SRC_DIR/example/ $DST_DIR/ -raf

	cp $SRC_DIR/testing/ $DST_DIR/ -raf

	cp $SRC_DIR/doc/ $DST_DIR/ -raf

#	cp $SRC_DIR/etc/ $DST_DIR/ -raf
	
#	cp $SRC_DIR/code-skltn/ $DST_DIR/ -raf

#	code-skltn
	
#	fmt_cvt

	echo create link file ...
	pwd
	chmod +x -R  $DST_DIR/bin/*  $DST_DIR/shlib/*  $DST_DIR/testing/*
	
	for file in `cd $DST_DIR/bin; find *`; do
#	    echo file：$DST_DIR/bin/$file
	    ln -svf $DST_DIR/bin/$file $ROOTFS/bin/$file
	done
	
	echo shlib/$soft_name
#	rm $ROOTFS/usr/shlib/$soft_name -rf
#	mkdir $ROOTFS/usr/shlib/$soft_name -pv
#	ln -sf $DST_DIR/shlib/$soft_name/ $ROOTFS/usr/shlib/$soft_name
	for file in `cd $DST_DIR/shlib/; find *`; do
#	    echo file：$DST_DIR/shlib/$soft_name/$file
		tmp="$ROOTFS/usr/shlib/$file"
		if [[ -d $tmp ]]; then
			mkdir $tmp -pv
		else
			tmp=`dirname $tmp`
			[[ ! -e $tmp ]] && mkdir $tmp -pv
			ln -svf $DST_DIR/shlib/$file $ROOTFS/usr/shlib/$file
		fi
	done

    return
		
	mkdir $ROOTFS/usr/minc/shlib-lite/$file -pv
	for file in `cd $DST_DIR/code-skltn/; find *`; do
#	    echo file：$DST_DIR/code-skltn/$file
	    ln -svf $DST_DIR/code-skltn/$file $ROOTFS/usr/minc/shlib-lite/$file
	done
	
	return
}

uninstall ()
{
	# exit调用
	
	# 删除安装文件
	
	# 根据需要，删除dvar
	return
}


######################
# section: public函数
######################




#
# main <eval-str>
#
main ()
{
	local varin=$1
	local varout=$2
	local func="txtfmt_"
	
	install
	
	return
	
	#
	# 参数解析
	#
	while getopts :n:ef:o:v:aAh opt; do
		case "$opt" in
			n)
			eval_cnt="$opt"
			;;
			e)
			evstrn_mode="txt-eval"
			;;
			f)
			fin="$opt"
			;;
			o)
			fout="$opt"
			;;
			v)
			var="$opt"
			;;
			a)
			inst_paths_gen
			;;
			A)
			inst_paths_gen
			;;
			h)
			echo -ne "$evstrn_usage"
			;;
			*)
			echo -ne "does not use '-$opt' opt.\n"
			;;
		esac
	done
	
	if [[ evstrn_mode == "eval" ]]; then
		evaln
	fi
	
	if [[ evstrn_mode == "txt-eval" ]]; then
		if [[ $varin != '-' ]]; then
			func+="var"
		else
			func+="pipe"
		fi
	
		if [[ $varin != '-' ]]; then
			func+="2var"
		else
			func+="2pipe"
		fi
		
		[[ -z $varin ]] && func=txtfmt_pipe2pipe && varout="" && varin=""
		[[ -z $varout && -n $varin ]] && funcname=txtfmt_var2pipe && varout=$varin && varin=fmt_$varin
		
		# 实际运行的是pipe2pipe，文件和环境变量转换为pipe进行处理。
		$funcname $varin $varout
	fi
}


main "$@"

######################
# section: file tail
######################

