#!/bin/bash
############################################################
# source: 1.lib_path_testing.sh
# author: devenkong(18151155@qq.com)
# date: 2021-10-03
############################################################
# Copyright (C) 2022- Free Software Foundation, Inc.
# This configure script is free software; the Free Software 
# Foundation gives unlimited permission to copy, distribute 
# and modify it.
############################################################
# note:
#     在不同的系统下，shlib的路径有所不同。例如像是安卓的busybox命令
# 行环境下，根目录的路径是位于一个app的数据目录中的，所以程序的运行，
# 库文件的引用，都需要路径设置，便于适配不同的运行环境。
############################################################

TESTING_ROOT_DIR=
TESTING_TMP_DIR=~/.testing/$0/


testing ()
{
	# install lib files
	install $type $name $filetype $srcfile
	
	# check from lib path
	if [[ -f $srcfile ]]; then
		echo "file installed to shlib successfull."
	else
		echo "file install to shlib failed."
	fi
	
	# use source with lib path prefix
	source $SHLIB_PATH/$srcfile
	
	# invoke test func
	test_foo
	
	# uninstall
	echo "uninstall file from lib."
	uninstall $type $name $filetype $srcfile
}


main ()
{
	echo "\n1.库文件引用路径测试。"
	rm $TESTING_TMP_DIR/ -rf
	mkdir -p $TESTING_TMP_DIR
	cp 1.*.sh* scripts $TESTING_TMP_DIR -rf
	cd $TESTING_TMP_DIR
	chmod +x *.sh scripts/*
	
	testing "$@" 2>&1 > log.txt
	
	diff log.txt 1.*.sh.*.txt > diff.txt
	if [[ -z "`cat diff.txt`" ]]; then
		echo "[  ok  ]"
	else
		echo "[failed]"
	fi
}

. dsource
#source $SHLIB_PATH/dsource.shlib

ROOTFS="`dirname $(which ls)`/.."
SHLIB_PATH=$ROOTFS/usr/shlib

. $SHLIB_PATH/dbgout.shlib
#dsource dbgout.shlib
#dsource shellprog.shlib

