#!/bin/bash
############################################################
# source: 1.dsource_file_inc_testing.sh
# author: devenkong(18151155@qq.com)
# date: 2021-10-03
############################################################
# Copyright (C) 2022- Free Software Foundation, Inc.
# This configure script is free software; the Free Software 
# Foundation gives unlimited permission to copy, distribute 
# and modify it.
############################################################
# note:
#     include脚本程序在可执行程序目录中，所以引用时不需要路径前缀。
#     在include中的dsource函数中，对source的使用添加了$SHLIB_PATH
# 库目录定义，便于用于直接引用shlib库，在不同的系统环境下可使得程序更
# 通用。
############################################################

. shlibinc
include stdio.shlib

TESTING_ROOT_DIR=
TESTING_TMP_DIR=~/.testing/$0/

. dsource
#source $SHLIB_PATH/dsource.shlib

ROOTFS="`dirname $(which ls)`/.."
SHLIB_PATH=$ROOTFS/usr/shlib

testing ()
{
	dbgout "test dbgout() func invoking."
}

main ()
{
	echo "\n2.使用dsource库文件引用测试。"
	rm $TESTING_TMP_DIR/ -rf
	mkdir -p $TESTING_TMP_DIR
	cp 1.*.sh* scripts $TESTING_TMP_DIR -rf
	cd $TESTING_TMP_DIR
	chmod +x *.sh scripts/*
	
	testing "$@" 2>&1 > log.txt
	
	diff log.txt 1.*.sh.*.txt > diff.txt
	if [[ -z "`cat diff.txt`" ]]; then
		echo "[  ok  ]"
	else
		echo "[failed]"
	fi
}

