
#!/bin/bash
############################################################
# source: shlib
# author: devenkong(18151155@qq.com)
# date: 2022-07-29
############################################################
# Copyright (C) 2022- Free Software Foundation, Inc.
# This configure script is free software; the Free Software 
# Foundation gives unlimited permission to copy, distribute 
# and modify it.
############################################################
# note:
#     use dbgout.shlib for debuging.
############################################################

#
# todo：
# @ 
# @ 
#

. shlibinc


##############################
# section: shlib include
##############################

include gplib.shlib
include dbgout.shlib


##############################
# section: public comment info
##############################




##############################
# section: variable define
##############################

longstr="adhdhjdjfjfjdjdjd
djjdjfjjffjjfjdk
djdjjedjdhvhvur
jfjrriekddnhffk
fjkdslsosojf
djjrekksijfuvugufhr
fjdjdjkjfhfhfhddjj
fkkforoeoeidjchshhsejj
fjrrbdhhducucjdsjje"


##############################
# section: private function
##############################

stub_debug ()
{
	#
	# here is the example for stub debug
	# use stub string to seperate application string info,
	# if some of the code running error, it shows error code where it
	# is invoked.
	#
	
	dbgout "xxxxxxxxxxxx step1 xxxxxxxxxxxx\n"
	
	echo 11111
	dbgout "xxxxxxxxxxxx step2 xxxxxxxxxxxx\n"
	
	echo 22222
	dbgout "xxxxxxxxxxxx step3 xxxxxxxxxxxx\n"
	
	echo 33333
	dbgout "xxxxxxxxxxxx step4 xxxxxxxxxxxx\n"
	
	duehehjs
	dbgout "xxxxxxxxxxxx step5 xxxxxxxxxxxx\n"
	
	echo 55555
	dbgout "xxxxxxxxxxxx step6 xxxxxxxxxxxx\n"
}

func_for_test ()
{
	#
	# using stub to locate in src code
	# it can be used for branch structure code.
	#
	if [[ 1 == 1 ]]; then
		dbgout_file_stub
		dbgout_func_stub
		
		echo application string output.
		
		#
		# display invoke stack to get the code location.
		#
		dbgout_trace
	fi
}


##############################
# section: public function
##############################

#
# main <eval-str>
#
main ()
{
	local testvar=aaa
	local cnt=0
	echo "func-paramter:"
	
	init_dbglogout 2 shlibopt 20000
	
	info "this example shows how to use debug infomation output function in sub-process of while loop."
	
	echo xxxxxxxxxxxxxxxxxxxxxxxxx
	
	echo testvar=$testvar
	
	#
	# use dbgoutvar to display long string by var name.
	#
	dbgoutvar longstr
	
	#
	# display data as hex string.
	#
	echo dbgout_hex | dbgout_hex
	
	while read line; do
	    : $(( cnt++ ))
		info cnt=$cnt
		[[ $cnt == 5 ]] && break
		
		func_for_test
		
		#
		# output string on debug channel
		#
		dbgout_cmd ls / -l
		
		#
		# debug pause as a single step
		#
		dbgstub_pause
		
		info testvar=$testvar
		echo xxx $line
		echo "echo string in logfile."
		dbgout "output debug string here.\n"
		info "output info string on tty console."
	done < <(cat sceipts/data.txt) > output.txt 
	
	echo at last, cnt=$cnt
	echo output.txt is:
	cat output.txt
	
	echo xxxxxxxxxxxxxxxxxxxxxxxxx
}


main "$@"

##############################
# section: file tail
##############################
