#!/bin/bash
############################################################
# source: 1.dbgout_color_testing.sh
# author: devenkong(18151155@qq.com)
# date: 2021-10-04
############################################################
# Copyright (C) 2022- Free Software Foundation, Inc.
# This configure script is free software; the Free Software 
# Foundation gives unlimited permission to copy, distribute 
# and modify it.
############################################################
# note:
#     dbgout的彩色输出显示测试。
############################################################

. shlibinc
include stdio.shlib

TESTING_ROOT_DIR=
TESTING_TMP_DIR=~/.testing/$0/


testing ()
{
	local i
	
	init_dbgout testing testing 20000
	
	dbgout "$TCLEAR用于清除显示内容。"
	dbgout "$BCWHITE$FCBLACK白底黑字, white background, black font.$CNORMAL"
	dbgout "$BCCYAN$FCREDK青底红字, white background, red font.$CNORMAL"
	dbgout "$BCMAGENTA$FCGREEN紫底绿字, white background, green font.$CNORMAL"
	dbgout "$BCBLUE$FCYELLOW蓝底黄字, blue background, yellow font.$CNORMAL"
	dbgout "$BCYELLOW$FCBLUE黄底蓝字, yellow background, blue font.$CNORMAL"
	dbgout "$BCGREEN$FCMAGENTA绿底紫字, green background, magenta font.$CNORMAL"
	dbgout "$BCRED$FCCYAN红底青字, red background, cyan font.$CNORMAL"
	dbgout "$BCBLACK$FCWHITE黑底白字, black background, white font.$CNORMAL"
	
	dbgout "$BCWHITE$FCBLACK$CHIGHL白底黑字, 高亮显示, white background, black fon, with hiligh display.$CNORMAL"
	
	dbgout "$BCWHITE$FCBLACK$CUNDERLINE黑底白字, 下划线, black background, white fon, with under line.$CNORMAL"
	dbgout "$BCWHITE$FCBLACK$CUNDERLINE黑底白字, 闪烁, black background, white fon, with flash.$CNORMAL"
	dbgout "$BCWHITE$FCBLACK$CUNDERLINE黑底白字, 反色, black background, white fon, with reverse.$CNORMAL"
	dbgout "$BCWHITE$FCBLACK$CUNDERLINE黑底白字, 消隐, black background, white fon, with hidden.$CNORMAL"
	
	# 恢复光标位置，清除光标位置到末尾信息，保存光标位置，输出字符串
	for (( i=0; i<10; i++ )); do
		dbgout "\r$THIDCUR$TRESTORECUR$TCLR2END$TSAVECUR/ 旋转的光标$TSHOWCUR"
		usleep 200000
		dbgout "\r$THIDCUR$TRESTORECUR$TCLR2END$TSAVECUR- 旋转的光标$TSHOWCUR"
		usleep 200000
		dbgout "\r$THIDCUR$TRESTORECUR$TCLR2END$TSAVECUR\ 旋转的光标$TSHOWCUR"
		usleep 200000
		dbgout "\r$THIDCUR$TRESTORECUR$TCLR2END$TSAVECUR- 旋转的光标$TSHOWCUR"
		usleep 200000
	done
	
	echo "[logfile]"
	cat $logfile_path/$log_file
}

main ()
{
	echo "\n1.调试信息输出测试。"
	rm $TESTING_TMP_DIR/ -rf
	mkdir -p $TESTING_TMP_DIR
	cp 1.*.sh* scripts $TESTING_TMP_DIR -rf
	cd $TESTING_TMP_DIR
	chmod +x *.sh scripts/*
	
	testing "$@" 2>&1 > log.txt
	
	diff log.txt 1.*.sh.*.txt > diff.txt
	if [[ -z "`cat diff.txt`" ]]; then
		echo "[  ok  ]"
	else
		echo "[failed]"
	fi
}

